/*
 * Suplementary Services Thrasher
 *
 * Copyright (C) 2005 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* *INDENT-OFF* */

lc_char PROGMEM lc_Nr_Send[]={
        LC_EN("How many sendings? ")
        LC_CZ("Kolik? ")
        LC_END
};

static lc_char PROGMEM lc_Sending[]={
        LC_EN("Sending ")
        LC_CZ("Posilam ")
        LC_END
};

static lc_char PROGMEM lc_Failed[]={
        LC_EN("Failed sending ")
        LC_CZ("Selhani ")
        LC_END
};

u8 PROGMEM t_SSPal[] = "SS Thrasher";

u8 PROGMEM t_ss[] = { 0xff, 0xba, 0x12, 0xfb, 0x00 }; //"*#12#";

/* *INDENT-ON* */

void sspal (Menu_selection_data * x)
{
  u8 *res;
  u8 i;
  u8 len;
  u8 l;
  u8 err = NO_ERROR;
  u8 *buf = buf_A ();
  u16 nr_to_send;
  u16 nr_send;
  u8 *r;
  u8 *alpha;

  alpha = malloc (100);
  if (alpha == NULL)
  {
    err = ERR_NO_RAM;
    goto X_END;
  }

  res = get_input (locale (lc_Nr_Send), 1, 3, NULL, Q_GET_INPUT_DIGITS);
  if (res == ENULL || res == NULL)
    goto X_END;

  res[res[0] + 1] = '\0';
  nr_to_send = atoi (&res[2]);

  if (nr_to_send == 0)
    goto X_END;

  nr_send = 0;

X_SEND:
  while (nr_send < nr_to_send)
  {
    dbsp (">SEND_SS\n");

    r = alpha;
    r = sprints (r, locale (lc_Sending));
    r = sprinti (r, nr_send + 1);
    r = sprintc (r, '/');
    r = sprinti (r, nr_to_send);
    r = sprintc (r, '\n');
    r = sprintc (r, '\0');

    len = 0;

    l = strlen (alpha);

    buf[len++] = T_ALPHA_ID;
    buf[len++] = l;
    for (i = 0; i < l; i++)
      buf[len++] = rb (alpha + i);

    l = strlen (t_ss);

    buf[len++] = T_SS_STRING | CR_FLAG;
    buf[len++] = l;
    for (i = 0; i < l; i++)
      buf[len++] = rb (t_ss + i);

    res = stk_cmd (STK_CMD_SEND_SS, 0x00, DEV_ID_NETWORK, len);

    dbsp ("<SEND_SS\n");

    nr_send++;
  }

X_END:
  free (alpha);

  if (err != NO_ERROR)
    perror (err);
}

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_INSERT_MENU:
      insert_menu (t_SSPal);
      break;
    case ACTION_MENU_SELECTION:
      stk_thread (sspal, NULL);
      break;
    default:
      break;
  }
}
